#include "main_control_impl.h"

main_control_t g_main_control = {
	.motors = {
		#if MAIN_CONTROL_NUM_MOTORS > 0
		{
			#if MAIN_CONTROL_THUMB_MOTOR_CONTROLLER == 0
			.i2c_address = 0,
			#else
			.i2c_address = MAIN_CONTROL_THUMB_MOTOR_CONTROLLER + MOTOR_PROTOCOL_BASE_ADDRESS - 1,
			#endif
			.controller_index = MAIN_CONTROL_THUMB_MOTOR_CONTROLLER - 1,
			.motor_index = MAIN_CONTROL_THUMB_MOTOR_INDEX - 1,
			.calibration_group = MAIN_CONTROL_THUMB_CALIB_GROUP,
			.open_at_positive = MAIN_CONTROL_IS_GEAR_FLIPPING_DIRECTION(MAIN_CONTROL_THUMB_GEAR_RATIO) ? !MAIN_CONTROL_THUMB_OPEN_AT_POS : MAIN_CONTROL_THUMB_OPEN_AT_POS,
			.gear_ratio = MAIN_CONTROL_GET_GEAR_RATIO(MAIN_CONTROL_THUMB_GEAR_RATIO),
			.state = {0},
			.limits = {0},
		},
		#endif
		#if MAIN_CONTROL_NUM_MOTORS > 1
		{
			#if MAIN_CONTROL_INDEX_MOTOR_CONTROLLER == 0
			.i2c_address = 0,
			#else
			.i2c_address = MAIN_CONTROL_INDEX_MOTOR_CONTROLLER + MOTOR_PROTOCOL_BASE_ADDRESS - 1,
			#endif
			.controller_index = MAIN_CONTROL_INDEX_MOTOR_CONTROLLER - 1,
			.motor_index = MAIN_CONTROL_INDEX_MOTOR_INDEX - 1,
			.calibration_group = MAIN_CONTROL_INDEX_CALIB_GROUP,
			.open_at_positive = MAIN_CONTROL_IS_GEAR_FLIPPING_DIRECTION(MAIN_CONTROL_INDEX_GEAR_RATIO) ? !MAIN_CONTROL_INDEX_OPEN_AT_POS : MAIN_CONTROL_INDEX_OPEN_AT_POS,
			.gear_ratio = MAIN_CONTROL_GET_GEAR_RATIO(MAIN_CONTROL_INDEX_GEAR_RATIO),
			.state = {0},
			.limits = {0},
		},
		#endif
		#if MAIN_CONTROL_NUM_MOTORS > 2
		{
			#if MAIN_CONTROL_MIDDLE_MOTOR_CONTROLLER == 0
			.i2c_address = 0,
			#else
			.i2c_address = MAIN_CONTROL_MIDDLE_MOTOR_CONTROLLER + MOTOR_PROTOCOL_BASE_ADDRESS - 1,
			#endif
			.controller_index = MAIN_CONTROL_MIDDLE_MOTOR_CONTROLLER - 1,
			.motor_index = MAIN_CONTROL_MIDDLE_MOTOR_INDEX - 1,
			.calibration_group = MAIN_CONTROL_MIDDLE_CALIB_GROUP,
			.open_at_positive = MAIN_CONTROL_IS_GEAR_FLIPPING_DIRECTION(MAIN_CONTROL_MIDDLE_GEAR_RATIO) ? !MAIN_CONTROL_MIDDLE_OPEN_AT_POS : MAIN_CONTROL_MIDDLE_OPEN_AT_POS,
			.gear_ratio = MAIN_CONTROL_GET_GEAR_RATIO(MAIN_CONTROL_MIDDLE_GEAR_RATIO),
			.state = {0},
			.limits = {0},
		},
		#endif
		#if MAIN_CONTROL_NUM_MOTORS > 3
		{
			#if MAIN_CONTROL_RING_MOTOR_CONTROLLER == 0
			.i2c_address = 0,
			#else
			.i2c_address = MAIN_CONTROL_RING_MOTOR_CONTROLLER + MOTOR_PROTOCOL_BASE_ADDRESS - 1,
			#endif
			.controller_index = MAIN_CONTROL_RING_MOTOR_CONTROLLER - 1,
			.motor_index = MAIN_CONTROL_RING_MOTOR_INDEX - 1,
			.calibration_group = MAIN_CONTROL_RING_CALIB_GROUP,
			.open_at_positive = MAIN_CONTROL_IS_GEAR_FLIPPING_DIRECTION(MAIN_CONTROL_RING_GEAR_RATIO) ? !MAIN_CONTROL_RING_OPEN_AT_POS : MAIN_CONTROL_RING_OPEN_AT_POS,
			.gear_ratio = MAIN_CONTROL_GET_GEAR_RATIO(MAIN_CONTROL_RING_GEAR_RATIO),
			.state = {0},
			.limits = {0},
		},
		#endif
		#if MAIN_CONTROL_NUM_MOTORS > 4
		{
			#if MAIN_CONTROL_PINKY_MOTOR_CONTROLLER == 0
			.i2c_address = 0,
			#else
			.i2c_address = MAIN_CONTROL_PINKY_MOTOR_CONTROLLER + MOTOR_PROTOCOL_BASE_ADDRESS - 1,
			#endif
			.controller_index = MAIN_CONTROL_PINKY_MOTOR_CONTROLLER - 1,
			.motor_index = MAIN_CONTROL_PINKY_MOTOR_INDEX - 1,
			.calibration_group = MAIN_CONTROL_PINKY_CALIB_GROUP,
			.open_at_positive = MAIN_CONTROL_IS_GEAR_FLIPPING_DIRECTION(MAIN_CONTROL_PINKY_GEAR_RATIO) ? !MAIN_CONTROL_PINKY_OPEN_AT_POS : MAIN_CONTROL_PINKY_OPEN_AT_POS,
			.gear_ratio = MAIN_CONTROL_GET_GEAR_RATIO(MAIN_CONTROL_PINKY_GEAR_RATIO),
			.state = {0},
			.limits = {0},
		},
		#endif
		#if MAIN_CONTROL_NUM_MOTORS > 5
		{
			#if MAIN_CONTROL_MISC_MOTOR_CONTROLLER == 0
			.i2c_address = 0,
			#else
			.i2c_address = MAIN_CONTROL_MISC_MOTOR_CONTROLLER + MOTOR_PROTOCOL_BASE_ADDRESS - 1,
			#endif
			.controller_index = MAIN_CONTROL_MISC_MOTOR_CONTROLLER - 1,
			.motor_index = MAIN_CONTROL_MISC_MOTOR_INDEX - 1,
			.calibration_group = MAIN_CONTROL_MISC_CALIB_GROUP,
			.open_at_positive = MAIN_CONTROL_IS_GEAR_FLIPPING_DIRECTION(MAIN_CONTROL_MISC_GEAR_RATIO) ? !MAIN_CONTROL_MISC_OPEN_AT_POS : MAIN_CONTROL_MISC_OPEN_AT_POS,
			.gear_ratio = MAIN_CONTROL_GET_GEAR_RATIO(MAIN_CONTROL_MISC_GEAR_RATIO),
			.state = {0},
			.limits = {0},
		}
		#endif
	}
};
